;;; vollstaendige Tiefensuche [mit besucht - Liste]:
(require (lib "breakpoint.ss")) ; enthaelt writeln
;;;===== Tiefensuche =========================================
(define
  (Tiefensuche Labyrinth Knoten Zielknoten besucht Nachfolgeknoten)   
  
  (cond
    ((equal? Knoten Zielknoten)                         ; [Anm.1]
     (writeln (reverse besucht)))
    
    ((null? Nachfolgeknoten)                            ; [Anm.2]
     #f)
    
    ((member (car Nachfolgeknoten) besucht)             ; [Anm.3]
     (Tiefensuche
      Labyrinth
      Knoten
      Zielknoten
      besucht
      (cdr Nachfolgeknoten)))
    
    (else
     (Tiefensuche                                      ; [Anm.4]
      Labyrinth
      (car Nachfolgeknoten)
      Zielknoten
      (cons (car Nachfolgeknoten) besucht)
      (Nachfolger (car Nachfolgeknoten) Labyrinth))
    
     (Tiefensuche                                      ; [Anm.5]
      Labyrinth
      Knoten
      Zielknoten
      besucht
      (cdr Nachfolgeknoten)))))

;;; ===== Nachfolger ==========================================
;;; Funktion zur Bestimmung der Nachfolgeknoten
(define
  (Nachfolger Knoten Labyrinth)
  (cadr (assoc Knoten Labyrinth)))

;;; ===== Labyrinth ===========================================
; Dieses Labyrinth enth?lt Zyklen.
(define
  Labyrinth
  '((0 (3))
    (1 (2 4))
    (2 (1))
    (3 (0 4))
    (4 (1 3 5 7))
    (5 (4 8))
    (6 (9))
    (7 (4 8 10))
    (8 (5 7))
    (9 (6 10 12))
    (10 (7 9 11 13))
    (11 (10))
    (12 (9))
    (13 (10 14))
    (14 (13))))
;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;;;  0          1    ---   2          
;;;  
;;;  |          |                     
;;;  
;;;  3    ---   4    ---   5          
;;;  
;;;             |          |          
;;;  
;;;  6          7    ---   8          
;;;  
;;;  |          |                     
;;;  
;;;  9    ---   10   ---   11         
;;;  
;;;  |          |                     
;;;
;;;  12         13   ---   14         

(Tiefensuche Labyrinth 0 8 (list 0) (Nachfolger 0 Labyrinth))